// create.cpp
//   Creates a GP oddly enough...

/* Genetic Programming System using the C++ programming language

 Input is of the form gp <pop> <gen> <output file>

 A Potted History:

	 Version 1.00 BETA (sometime March 1993). Very Buggy,...
	 Version 2.00 C++ version very easy language 16 July 1993
								ERRORS in load and saving a genetic program.
											 No capacity for extended memory in DOS.
											 No differing creation mechanism.
											 No touranment selection
											 No capacity for encapsulation
	 Version 3.00 C++ Version.( Uncompatible with previous versions )
											 Robust with full use of OOP techniques.
											 Compatibility with ANSI standard.
											 Ramped half and half implemented.
											 Tournament selection implemented.
											 Changing variables does not require recompiling.
											 BUT STILL
											 No capacity for expanded or extended memory in DOS.
											 No capacity for encapsulation.

	 C version in progress
	 Windows version in progress but its all gobblydegook.


	 Version 3.00 can be compiled in the DOS and UNIX domain
	 but NOT in Windows. This was not made clear in previous programs.

 Genetic programming in C++ was designed and choreographed by Adam P.Fraser

		Food parcels, cash and trashy sci-fi novels to:

					 a.fraser@eee.salford.ac.uk
					snail:
					 A.Fraser
					 PostGraduate Section,
					 Maxwell Building,
					 Elec & Elec Eng,
					 University Of Salford,
					 Salford,
					 M5 4WT.
					 England


		Your comments, improvements and complaints are welcome.


 This code is intended as a base for C++ GPers. Please if you adapt the code
 send me a msg. Also could you please keeps these comments and my address in
 the code.

							regards,
											Adam Fraser ;-)
											16 November 1993

	' and one day there shall come an artificial ant who can complete the santa
	fe trail in 400 evaluation steps and on that day there shall be oink flap'
*/


#include "gp.hpp"
#include "function.hpp"
#include "terminal.hpp"

// Create for genetic program. Major workhorse ...

// NB this could be put in an overlay file as it is only called at the start

//  Notes: This code makes a function the first node this is in line with
// Koza's LISP code and does make the trees more interesting but it is not
//  necessary....																APF



void GP::Create( CREATIONTYPE ctype, int allowabledepth )
{
	Function *tempfunc = FunctionSet->Choose();

	if ( !(pgHeader = new Gene) ) ExitSystem("GP::Create");

	pgHeader->iValue = function( tempfunc );

	pgHeader->pgNext = NULL;

	if ( !(pgHeader->pgChild = new Gene) ) ExitSystem("GP::Create");

	switch ( ctype )
	{
		case GROW :
			pgHeader->pgChild->CreateGrowChildren( arguments(tempfunc),
																										--allowabledepth );
			break;

		default :
			pgHeader->pgChild->CreateVariableChildren( arguments(tempfunc),
																										--allowabledepth );
			break;
	}

	Length();
}


void Gene::CreateVariable( int allowabledepth )
{
	if ( allowabledepth == 0 )
	{
		iValue = terminal( TerminalSet->Choose() );
		pgChild = NULL;
	}
	else
	{
		if ( ( rand() % 6 ) < 3 )   // 50/50 chance of getting func or term
		{
			Function *tempfunc = FunctionSet->Choose();

			iValue = function( tempfunc );

			if ( !(pgChild = new Gene) )	ExitSystem( "Gene::CreateGP" );

			pgChild->CreateVariableChildren( arguments( tempfunc ), --allowabledepth );
		}
		else
		{
			iValue = terminal( TerminalSet->Choose() );
			pgChild = NULL;
		}
	}
}


void Gene::CreateVariableChildren( int value, int allowabledepth )
{
	CreateVariable( allowabledepth );

	if ( value > 1 )
	{
		if ( !(pgNext = new Gene) ) ExitSystem( "GP::CreateChildren" );
		pgNext->CreateVariableChildren( --value, allowabledepth );
	}
}


void Gene::CreateGrow( int allowabledepth )
{
	if ( allowabledepth == 0 )
	{
		iValue = terminal( TerminalSet->Choose() );
		pgChild = NULL;
	}
	else
	{
		if ( ( rand() % 6 ) < 3 )   // 50/50 chance of getting func or term
		{
			Function *tempfunc = FunctionSet->Choose();

			iValue = function( tempfunc );

			if ( !(pgChild = new Gene) )	ExitSystem( "Gene::CreateGP" );

			pgChild->CreateGrowChildren( arguments( tempfunc ), --allowabledepth );
		}
		else
		{
			iValue = terminal( TerminalSet->Choose() );
			pgChild = NULL;
		}
	}
}


void Gene::CreateGrowChildren( int value, int allowabledepth )
{
	CreateGrow( allowabledepth );

	if ( value > 1 )
	{
		if ( !(pgNext = new Gene) ) ExitSystem( "GP::CreateChildren" );
		pgNext->CreateGrowChildren( --value, allowabledepth );
	}
}
